<?php
/*
Plugin Name: Zuper - Shoutcast and Icecast Radio Player With History
Description: This plugin will allow you to insert an advanced HTML5 Radio Player with history support
Version: 3.4
Author: پرشین اسکریپت
Author URI: https://www.persianscript.ir
*/

ini_set('display_errors', 0);
$lbg_audio9_html5_radio_zuper_path = trailingslashit(dirname(__FILE__));  //empty

//all the messages
$lbg_audio9_html5_radio_zuper_messages = array(
		'version' => '<div class="error">Zuper - Shoutcast and Icecast Radio Player With History plugin requires WordPress 3.0 or newer. <a href="https://codex.wordpress.org/Upgrading_WordPress">Please update!</a></div>',
		'data_saved' => 'Data Saved!',
		'empty_name' => 'Name - required',
		'empty_stream' => 'Stream - required',
		'empty_mp3' => 'MP3 - required',
		'empty_ogg' => 'OGG - required',
		'empty_categ' => 'Category - required',
		'invalid_request' => 'Invalid Request!',
		'generate_for_this_player' => 'You can start customizing this player.',
		'duplicate_complete' => 'Duplication process is complete!'
	);


global $wp_version;

if ( !version_compare($wp_version,"3.0",">=")) {
	die ($lbg_audio9_html5_radio_zuper_messages['version']);
}




function lbg_audio9_html5_radio_zuper_activate() {
	//db creation, create admin options etc.
	global $wpdb;

	$lbg_audio9_html5_radio_zuper_collate = ' COLLATE utf8_general_ci';

	$sql0 = "CREATE TABLE `" . $wpdb->prefix . "lbg_audio9_html5_radio_zuper_players` (
			`id` INT UNSIGNED NOT NULL AUTO_INCREMENT ,
			`name` VARCHAR( 255 ) NOT NULL ,
			PRIMARY KEY ( `id` )
			) ENGINE=MyISAM  DEFAULT CHARSET=utf8";

	$sql1 = "CREATE TABLE `" . $wpdb->prefix . "lbg_audio9_html5_radio_zuper_settings` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `playerWidth` smallint(5) unsigned NOT NULL DEFAULT '355',
  `imageHeight` smallint(5) unsigned NOT NULL DEFAULT '355',
  `radio_stream` varchar(255) NOT NULL DEFAULT '',
  `radio_name` varchar(255) NOT NULL DEFAULT 'Your Radio Title Here',
  `skin` varchar(255) NOT NULL DEFAULT 'blackControllers',
  `autoPlay` varchar(8) NOT NULL DEFAULT 'true',
  `responsive` varchar(8) NOT NULL DEFAULT 'true',
	`centerTitle` varchar(8) NOT NULL DEFAULT 'false',
  `songTitleColor` varchar(10) NOT NULL DEFAULT 'ffffff',
  `authorTitleColor` varchar(10) NOT NULL DEFAULT 'ffffff',
  `lineSeparatorColor` varchar(20) NOT NULL DEFAULT 'ffffff',
	`lineSeparatorOpacity` varchar(20) NOT NULL DEFAULT '50',
  `radioStationColor` varchar(10) NOT NULL DEFAULT 'ffffff',
	`buttonsOffState` varchar(10) NOT NULL DEFAULT 'ffffff',
	`buttonsOnState` varchar(10) NOT NULL DEFAULT '00AFEF',
  `frameBehindTextColor` varchar(10) NOT NULL DEFAULT '000000',
	`frameBehindTextImg` text,
  `playerBorderSize` smallint(5) unsigned NOT NULL DEFAULT '0',
  `playerBorderColor` varchar(10) NOT NULL DEFAULT '000000',
  `sticky` varchar(8) NOT NULL DEFAULT 'false',
  `startMinified` varchar(8) NOT NULL DEFAULT 'false',
  `centerPlayer` varchar(8) NOT NULL DEFAULT 'false',
  `showFacebookBut` varchar(8) NOT NULL DEFAULT 'true',
  `facebookAppID` varchar(255) NOT NULL DEFAULT '',
  `facebookShareTitle` varchar(255) NOT NULL DEFAULT 'HTML5 Radio Player With History - Shoutcast and Icecast',
  `facebookShareDescription` varchar(255) NOT NULL DEFAULT 'A top-notch responsive HTML5 Radio Player compatible with all major browsers and mobile devices.',
  `facebookShareImage` text,
  `showTwitterBut` varchar(8) NOT NULL DEFAULT 'true',
  `showVolume` varchar(8) NOT NULL DEFAULT 'true',
	`showBio` varchar(8) NOT NULL DEFAULT 'true',
	`translateBio` varchar(255) NOT NULL DEFAULT 'Bio',
	`bioAndLyricsColor` varchar(20) NOT NULL DEFAULT '000000',
  `showRadioStation` varchar(8) NOT NULL DEFAULT 'true',
  `showTitle` varchar(8) NOT NULL DEFAULT 'true',
  `showHistoryBut` varchar(8) NOT NULL DEFAULT 'true',
  `translateReadingData` varchar(255) NOT NULL DEFAULT 'reading data...',
  `historyTranslate` varchar(255) NOT NULL DEFAULT 'HISTORY - latest played songs',
  `historyTitleColor` varchar(20) NOT NULL DEFAULT '008aa4',
  `historyBgColor` varchar(20) NOT NULL DEFAULT 'FFFFFF',
	`historyBgColorAlpha` smallint(5) unsigned NOT NULL DEFAULT '90',
  `historyRecordBgColor` varchar(20) NOT NULL DEFAULT 'transparent',
	`historyRecordBottomBorderColor` varchar(20) NOT NULL DEFAULT 'transparent',
  `historyRecordSongColor` varchar(20) NOT NULL DEFAULT '000000',
  `historyRecordSongBottomBorderColor` varchar(20) NOT NULL DEFAULT '008aa4',
  `historyRecordAuthorColor` varchar(20) NOT NULL DEFAULT '6d6d6d',
	`historyRecordThumbBorderColor` varchar(20) NOT NULL DEFAULT '000000',
  `numberOfThumbsPerScreen` smallint(5) unsigned NOT NULL DEFAULT '3',
  `historyPadding` smallint(5) unsigned NOT NULL DEFAULT '16',
  `historyRecordTitleLimit` smallint(5) unsigned NOT NULL DEFAULT '25',
  `historyRecordAuthorLimit` smallint(5) unsigned NOT NULL DEFAULT '36',
  `nowPlayingInterval` smallint(5) unsigned NOT NULL DEFAULT '40',
  `grabLastFmPhoto` varchar(8) NOT NULL DEFAULT 'true',
  `noImageAvailable` text,
	`textureOverImage` text,
  `activateForFooter` varchar(8) NOT NULL DEFAULT 'false',
	`preserveOriginalUpperLowerCase` varchar(8) NOT NULL DEFAULT 'false',
	`delay` float unsigned NOT NULL DEFAULT '0.5',
	`url_custom_metdata_file` text,
	`metadata_file_type` text,
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8";



	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql0.$lbg_audio9_html5_radio_zuper_collate);
	dbDelta($sql1.$lbg_audio9_html5_radio_zuper_collate);


	//initialize the players table with the first player type
	$rows_count = $wpdb->get_var( "SELECT COUNT(*) FROM ". $wpdb->prefix ."lbg_audio9_html5_radio_zuper_players;" );
	if (!$rows_count) {
		$wpdb->insert(
			$wpdb->prefix . "lbg_audio9_html5_radio_zuper_players",
			array(
				'name' => 'Black Controllers'
			),
			array(
				'%s'
			)
		);
	}

	// initialize the settings
	$rows_count = $wpdb->get_var( "SELECT COUNT(*) FROM ". $wpdb->prefix ."lbg_audio9_html5_radio_zuper_settings;" );
	if (!$rows_count) {
		lbg_audio9_html5_radio_zuper_insert_settings_record(1);
	}




}



function lbg_audio9_html5_radio_zuper_insert_settings_record($player_id) {
	global $wpdb;
	$wpdb->insert(
			$wpdb->prefix . "lbg_audio9_html5_radio_zuper_settings",
			array(
				'skin' => 'blackControllers',
				'noImageAvailable' => plugins_url("", __FILE__).'/audio9_html5_radio_zuper/noimageavailable.jpg',
				'textureOverImage' => plugins_url("", __FILE__).'/audio9_html5_radio_zuper/controllers/texture4x4_1.png',
				'frameBehindTextImg' => plugins_url("", __FILE__).'/audio9_html5_radio_zuper/controllers/minimalBGD1.jpg'
			),
			array(
				'%s',
				'%s',
				'%s',
				'%s'
			)
		);
}


function lbg_audio9_html5_radio_zuper_init_sessions() {
	global $wpdb;
	if (is_admin()) {
		if (!session_id()) {
			session_start();

			//initialize the session
			if (!isset($_SESSION['xid'])) {
				$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_audio9_html5_radio_zuper_players) LIMIT 0, 1";
				$row = $wpdb->get_row($safe_sql,ARRAY_A);
				//$row=lbg_audio9_html5_radio_zuper_unstrip_array($row);
				$_SESSION['xid'] = $row['id'];
				$_SESSION['xname'] = $row['name'];
			}
		}
	}
}

function lbg_audio9_html5_radio_zuper_end_sessions() {
		if (is_admin()) {
			session_destroy();
		}
}

function lbg_audio9_html5_radio_zuper_load_styles() {
	if(strpos($_SERVER['PHP_SELF'], 'wp-admin') !== false) { //loads css in admin
		$page = (isset($_GET['page'])) ? $_GET['page'] : '';
		if(preg_match('/LBG_AUDIO9_HTML5_SHOUTCAST/i', $page)) {
			/*wp_enqueue_style('lbg-audio9-html5-shoutcast_jquery-custom_css', plugins_url('css/custom-theme/jquery-ui-1.8.10.custom.css', __FILE__));*/
			wp_enqueue_style('lbg-jquery-ui-custom_css', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.10.3/themes/pepper-grinder/jquery-ui.min.css');
			wp_enqueue_style('lbg-audio9-html5-shoutcast_css', plugins_url('css/styles.css', __FILE__));
			wp_enqueue_style('lbg-audio9-html5-shoutcast_colorpicker_css', plugins_url('css/colorpicker/colorpicker.css', __FILE__));

			wp_enqueue_style('thickbox');
		}
	} else if (!is_admin()) { //loads css in front-end
		wp_enqueue_style( 'wpb-google-fonts-PT-Sans', 'https://fonts.googleapis.com/css?family=PT+Sans:400,700', false );
		wp_enqueue_style('audio9-html5_site_css', plugins_url('audio9_html5_radio_zuper/audio9_html5.css', __FILE__));
	}
}

function lbg_audio9_html5_radio_zuper_load_scripts() {
	$page = (isset($_GET['page'])) ? $_GET['page'] : '';
	if(preg_match('/LBG_AUDIO9_HTML5_SHOUTCAST/i', $page)) {
		//loads scripts in admin
		//if (is_admin()) {
			/*wp_deregister_script('jquery-ui-core');
			wp_deregister_script('jquery-ui-widget');
			wp_deregister_script('jquery-ui-mouse');
			wp_deregister_script('jquery-ui-accordion');
			wp_deregister_script('jquery-ui-autocomplete');
			wp_deregister_script('jquery-ui-slider');
			wp_deregister_script('jquery-ui-tabs');
			wp_deregister_script('jquery-ui-sortable');
			wp_deregister_script('jquery-ui-draggable');
			wp_deregister_script('jquery-ui-droppable');
			wp_deregister_script('jquery-ui-selectable');
			wp_deregister_script('jquery-ui-position');
			wp_deregister_script('jquery-ui-datepicker');
			wp_deregister_script('jquery-ui-resizable');
			wp_deregister_script('jquery-ui-dialog');
			wp_deregister_script('jquery-ui-button');	*/

			wp_enqueue_script('jquery');
			/*wp_register_script('lbg-admin-jquery', plugins_url('js/jquery-1.5.1.js', __FILE__));
			wp_enqueue_script('lbg-admin-jquery');*/

			//wp_register_script('lbg-admin-jquery-ui-min', plugins_url('js/jquery-ui-1.8.10.custom.min.js', __FILE__));
			//wp_register_script('lbg-admin-jquery-ui-min', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.23/jquery-ui.min.js');
			/*wp_register_script('lbg-admin-jquery-ui-min', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.9.2/jquery-ui.min.js');
			wp_enqueue_script('lbg-admin-jquery-ui-min');*/
			wp_enqueue_script('jquery-ui-core');
			wp_enqueue_script('jquery-ui-widget');
			wp_enqueue_script('jquery-ui-mouse');
			wp_enqueue_script('jquery-ui-accordion');
			wp_enqueue_script('jquery-ui-autocomplete');
			wp_enqueue_script('jquery-ui-slider');
			wp_enqueue_script('jquery-ui-tabs');
			wp_enqueue_script('jquery-ui-sortable');
			wp_enqueue_script('jquery-ui-draggable');
			wp_enqueue_script('jquery-ui-droppable');
			wp_enqueue_script('jquery-ui-selectable');
			wp_enqueue_script('jquery-ui-position');
			wp_enqueue_script('jquery-ui-datepicker');
			wp_enqueue_script('jquery-ui-resizable');
			wp_enqueue_script('jquery-ui-dialog');
			wp_enqueue_script('jquery-ui-button');/***************************/

			wp_enqueue_script('jquery-form');
			wp_enqueue_script('jquery-color');
			wp_enqueue_script('jquery-masonry');
			wp_enqueue_script('jquery-ui-progressbar');
			wp_enqueue_script('jquery-ui-tooltip');

			wp_enqueue_script('jquery-effects-core');
			wp_enqueue_script('jquery-effects-blind');
			wp_enqueue_script('jquery-effects-bounce');
			wp_enqueue_script('jquery-effects-clip');
			wp_enqueue_script('jquery-effects-drop');
			wp_enqueue_script('jquery-effects-explode');
			wp_enqueue_script('jquery-effects-fade');
			wp_enqueue_script('jquery-effects-fold');
			wp_enqueue_script('jquery-effects-highlight');
			wp_enqueue_script('jquery-effects-pulsate');
			wp_enqueue_script('jquery-effects-scale');
			wp_enqueue_script('jquery-effects-shake');
			wp_enqueue_script('jquery-effects-slide');
			wp_enqueue_script('jquery-effects-transfer');

			wp_register_script('lbg-admin-colorpicker', plugins_url('js/colorpicker/colorpicker.js', __FILE__));
			wp_enqueue_script('lbg-admin-colorpicker');

			wp_register_script('lbg-admin-editinplace', plugins_url('js/jquery.editinplace.js', __FILE__));
			wp_enqueue_script('lbg-admin-editinplace');

			wp_register_script('lbg-admin-toggle', plugins_url('js/myToggle.js', __FILE__));
			wp_enqueue_script('lbg-admin-toggle');

			wp_enqueue_script('media-upload'); // before w.p 3.5
			wp_enqueue_media();// from w.p 3.5
			wp_enqueue_script('thickbox');



		//}

		//wp_enqueue_script('jquery');
		//wp_enqueue_script('jquery-ui-core');
		//wp_enqueue_script('jquery-ui-sortable');
		//wp_enqueue_script('thickbox');
		//wp_enqueue_script('media-upload');
		//wp_enqueue_script('farbtastic');
	} else if (!is_admin()) { //loads scripts in front-end
			/*wp_deregister_script('jquery-ui-core');
			wp_deregister_script('jquery-ui-widget');
			wp_deregister_script('jquery-ui-mouse');
			wp_deregister_script('jquery-ui-accordion');
			wp_deregister_script('jquery-ui-autocomplete');
			wp_deregister_script('jquery-ui-slider');
			wp_deregister_script('jquery-ui-tabs');
			wp_deregister_script('jquery-ui-sortable');
			wp_deregister_script('jquery-ui-draggable');
			wp_deregister_script('jquery-ui-droppable');
			wp_deregister_script('jquery-ui-selectable');
			wp_deregister_script('jquery-ui-position');
			wp_deregister_script('jquery-ui-datepicker');
			wp_deregister_script('jquery-ui-resizable');
			wp_deregister_script('jquery-ui-dialog');
			wp_deregister_script('jquery-ui-button');*/

		wp_enqueue_script('jquery');

		//wp_enqueue_script('jquery-ui-core');

		//wp_register_script('lbg-jquery-ui-min', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.23/jquery-ui.min.js');
		/*wp_register_script('lbg-jquery-ui-min', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.9.2/jquery-ui.min.js');
		wp_enqueue_script('lbg-jquery-ui-min');*/

			wp_enqueue_script('jquery-ui-core');
			/*wp_enqueue_script('jquery-ui-widget');
			wp_enqueue_script('jquery-ui-mouse');
			wp_enqueue_script('jquery-ui-accordion');
			wp_enqueue_script('jquery-ui-autocomplete');*/
			wp_enqueue_script('jquery-ui-slider');
			/*wp_enqueue_script('jquery-ui-tabs');
			wp_enqueue_script('jquery-ui-sortable');
			wp_enqueue_script('jquery-ui-draggable');
			wp_enqueue_script('jquery-ui-droppable');
			wp_enqueue_script('jquery-ui-selectable');
			wp_enqueue_script('jquery-ui-position');
			wp_enqueue_script('jquery-ui-datepicker');
			wp_enqueue_script('jquery-ui-resizable');
			wp_enqueue_script('jquery-ui-dialog');
			wp_enqueue_script('jquery-ui-button');

			wp_enqueue_script('jquery-form');
			wp_enqueue_script('jquery-color');
			wp_enqueue_script('jquery-masonry');
			wp_enqueue_script('jquery-ui-progressbar');
			wp_enqueue_script('jquery-ui-tooltip');*/

			wp_enqueue_script('jquery-effects-core');
			/*wp_enqueue_script('jquery-effects-blind');
			wp_enqueue_script('jquery-effects-bounce');
			wp_enqueue_script('jquery-effects-clip');
			wp_enqueue_script('jquery-effects-drop');
			wp_enqueue_script('jquery-effects-explode');
			wp_enqueue_script('jquery-effects-fade');
			wp_enqueue_script('jquery-effects-fold');
			wp_enqueue_script('jquery-effects-highlight');
			wp_enqueue_script('jquery-effects-pulsate');
			wp_enqueue_script('jquery-effects-scale');
			wp_enqueue_script('jquery-effects-shake');
			wp_enqueue_script('jquery-effects-slide');
			wp_enqueue_script('jquery-effects-transfer');*/

		wp_register_script('lbg-mousewheel', plugins_url('audio9_html5_radio_zuper/js/jquery.mousewheel.min.js', __FILE__));
		wp_enqueue_script('lbg-mousewheel');

		wp_register_script('lbg-touchSwipe', plugins_url('audio9_html5_radio_zuper/js/jquery.touchSwipe.min.js', __FILE__));
		wp_enqueue_script('lbg-touchSwipe');

		wp_register_script('lbg-audio9_html5', plugins_url('audio9_html5_radio_zuper/js/audio9_html5.js', __FILE__));
		wp_enqueue_script('lbg-audio9_html5');
	}

}



// adds the menu pages
function lbg_audio9_html5_radio_zuper_plugin_menu() {
	add_menu_page('LBG AUDIO9 HTML5 Admin Interface', 'LBG AUDIO9 HTML5', 'edit_posts', 'LBG_AUDIO9_HTML5_SHOUTCAST', 'lbg_audio9_html5_radio_zuper_overview_page',
	plugins_url('images/lbg_audio9_icon.png', __FILE__));
	add_submenu_page( 'LBG_AUDIO9_HTML5_SHOUTCAST', 'LBG AUDIO9 HTML5 Overview', 'Overview', 'edit_posts', 'LBG_AUDIO9_HTML5_SHOUTCAST', 'lbg_audio9_html5_radio_zuper_overview_page');
	add_submenu_page( 'LBG_AUDIO9_HTML5_SHOUTCAST', 'LBG AUDIO9 HTML5 Manage Players', 'Manage Players', 'edit_posts', 'LBG_AUDIO9_HTML5_SHOUTCAST_Manage_Players', 'lbg_audio9_html5_radio_zuper_player_manage_players_page');
	add_submenu_page( 'LBG_AUDIO9_HTML5_SHOUTCAST', 'LBG AUDIO9 HTML5 Manage Players Add New', 'Add New', 'edit_posts', 'LBG_AUDIO9_HTML5_SHOUTCAST_Add_New', 'lbg_audio9_html5_radio_zuper_player_manage_players_add_new_page');
	add_submenu_page( 'LBG AUDIO9 HTML5 Manage Players', 'LBG AUDIO9 HTML5 Player Settings', 'Player Settings', 'edit_posts', 'LBG_AUDIO9_HTML5_SHOUTCAST_Settings', 'lbg_audio9_html5_radio_zuper_player_settings_page');
	add_submenu_page( 'LBG_AUDIO9_HTML5_SHOUTCAST_Settings', 'LBG AUDIO9 HTML5 Player Settings', 'Duplicate Player', 'edit_posts', 'LBG_AUDIO9_HTML5_SHOUTCAST_Duplicate_Player', 'lbg_audio9_html5_radio_zuper_duplicate_player_page');
	add_submenu_page( 'LBG_AUDIO9_HTML5_SHOUTCAST', 'LBG AUDIO9 HTML5 Help', 'Help', 'edit_posts', 'LBG_AUDIO9_HTML5_SHOUTCAST_Help', 'lbg_audio9_html5_radio_zuper_player_help_page');
}


//HTML content for overview page
function lbg_audio9_html5_radio_zuper_overview_page()
{
	global $lbg_audio9_html5_radio_zuper_path;
	include_once($lbg_audio9_html5_radio_zuper_path . 'tpl/overview.php');
}

//HTML content for Manage Players
function lbg_audio9_html5_radio_zuper_player_manage_players_page()
{
	global $wpdb;
	global $lbg_audio9_html5_radio_zuper_messages;
	global $lbg_audio9_html5_radio_zuper_path;

	//delete player
	if (isset($_GET['id'])) {
		//delete from wp_lbg_audio9_html5_radio_zuper_players
		$wpdb->query($wpdb->prepare("DELETE FROM ".$wpdb->prefix."lbg_audio9_html5_radio_zuper_players WHERE id = %d",$_GET['id']));

		//delete from wp_lbg_audio9_html5_radio_zuper_settings
		$wpdb->query($wpdb->prepare("DELETE FROM ".$wpdb->prefix."lbg_audio9_html5_radio_zuper_settings WHERE id = %d",$_GET['id']));


		//initialize the session
		$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_audio9_html5_radio_zuper_players) ORDER BY id";
		$row = $wpdb->get_row($safe_sql,ARRAY_A);
		$row=lbg_audio9_html5_radio_zuper_unstrip_array($row);
		if ($row['id']) {
			$_SESSION['xid']=$row['id'];
			$_SESSION['xname']=$row['name'];
		}
	}


	$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_audio9_html5_radio_zuper_players) ORDER BY id";
	$result = $wpdb->get_results($safe_sql,ARRAY_A);
	//echo $wpdb->last_query;
	include_once($lbg_audio9_html5_radio_zuper_path . 'tpl/players.php');
	//include_once($lbg_audio9_html5_radio_zuper_path . 'tpl/overview.php');

}



//HTML content for Manage Players - Add New
function lbg_audio9_html5_radio_zuper_player_manage_players_add_new_page()
{
	global $wpdb;
	global $lbg_audio9_html5_radio_zuper_messages;
	global $lbg_audio9_html5_radio_zuper_path;

	//if($_POST['Submit'] == 'Add New') {
	if(array_key_exists('Submit', $_POST) && $_POST['Submit'] == 'Add New') {
		$errors_arr=array();
		if (empty($_POST['name']))
			$errors_arr[]=$lbg_audio9_html5_radio_zuper_messages['empty_name'];

		if (count($errors_arr)) {
				include_once($lbg_audio9_html5_radio_zuper_path . 'tpl/add_player.php'); ?>
				<div id="error" class="error"><p><?php echo implode("<br>", $errors_arr);?></p></div>
		  	<?php } else { // no errors
					$wpdb->insert(
						$wpdb->prefix . "lbg_audio9_html5_radio_zuper_players",
						array(
							'name' => $_POST['name']
						),
						array(
							'%s'
						)
					);
					//insert default player settings for this new player
					lbg_audio9_html5_radio_zuper_insert_settings_record($wpdb->insert_id);
					?>
						<div class="wrap">
							<div id="lbg_logo">
								<h2>Manage Players - Add New Player</h2>
				 			</div>
							<div id="message" class="updated"><p><?php echo $lbg_audio9_html5_radio_zuper_messages['data_saved'];?></p><p><?php echo $lbg_audio9_html5_radio_zuper_messages['generate_for_this_player'];?></p></div>
							<div>
								<p>&raquo; <a href="?page=LBG_AUDIO9_HTML5_SHOUTCAST_Add_New">Add New (player)</a></p>
								<p>&raquo; <a href="?page=LBG_AUDIO9_HTML5_SHOUTCAST_Manage_Players">Back to Manage Players</a></p>
							</div>
						</div>
		  	<?php }
	} else {
		include_once($lbg_audio9_html5_radio_zuper_path . 'tpl/add_player.php');
	}

}





//HTML content for playersettings
function lbg_audio9_html5_radio_zuper_player_settings_page()
{
	global $wpdb;
	global $lbg_audio9_html5_radio_zuper_messages;
	global $lbg_audio9_html5_radio_zuper_path;

	if (isset($_GET['id']) && isset($_GET['name'])) {
		$_SESSION['xid']=$_GET['id'];
		$_SESSION['xname']=$_GET['name'];
	}

	//$wpdb->show_errors();
	/*if (check_admin_referer('lbg_audio9_html5_radio_zuper_settings_update')) {
		echo "update";
	}*/


	//if($_POST['Submit'] == 'Update Player Settings') {
	if(array_key_exists('Submit', $_POST) && $_POST['Submit'] == 'Update Player Settings') {
		$_GET['xmlf']='';
		$except_arr=array('Submit','name','page_scroll_to_id_instances','pll_ajax_backend','page_scroll_to_id_instances','_wp_http_referer','set_key_auth','_wpnonce');
			$wpdb->update(
				$wpdb->prefix .'lbg_audio9_html5_radio_zuper_players',
				array(
				'name' => $_POST['name']
				),
				array( 'id' => $_SESSION['xid'] )
			);
			$_SESSION['xname']=stripslashes($_POST['name']);


			foreach ($_POST as $key=>$val){
				if (in_array($key,$except_arr)) {
					unset($_POST[$key]);
				}
			}

			$wpdb->update(
				$wpdb->prefix .'lbg_audio9_html5_radio_zuper_settings',
				$_POST,
				array( 'id' => $_SESSION['xid'] )
			);

			?>
			<div id="message" class="updated"><p><?php echo $lbg_audio9_html5_radio_zuper_messages['data_saved'];?></p></div>
	<?php
	}


	//echo "WP_PLUGIN_URL: ".WP_PLUGIN_URL;
	$safe_sql=$wpdb->prepare( "SELECT * FROM (".$wpdb->prefix ."lbg_audio9_html5_radio_zuper_settings) WHERE id = %d",$_SESSION['xid'] );
	$row = $wpdb->get_row($safe_sql,ARRAY_A);
	$row=lbg_audio9_html5_radio_zuper_unstrip_array($row);
	$_POST = $row;
	$_POST=lbg_audio9_html5_radio_zuper_unstrip_array($_POST);


	include_once($lbg_audio9_html5_radio_zuper_path . 'tpl/settings_form.php');

}




//HTML duplicate player
function lbg_audio9_html5_radio_zuper_duplicate_player_page()
{
	global $wpdb;
	global $lbg_audio9_html5_radio_zuper_messages;
	global $lbg_audio9_html5_radio_zuper_path;

	if (isset($_GET['id']) && isset($_GET['name'])) {
		$_SESSION['xid']=$_GET['id'];
		$_SESSION['xname']=$_GET['name'];
	}

	//$wpdb->show_errors();


	//echo "WP_PLUGIN_URL: ".WP_PLUGIN_URL;
	//$safe_sql=$wpdb->prepare( "INSERT INTO ".$wpdb->prefix ."lbg_audio9_html5_radio_zuper_settings SELECT * FROM (".$wpdb->prefix ."lbg_audio9_html5_radio_zuper_settings) WHERE id = %d",$_SESSION['xid'] );
	//insert player
	$wpdb->insert(
			$wpdb->prefix . "lbg_audio9_html5_radio_zuper_players",
			array(
				'name' => 'Duplicate of Player '.$_SESSION['xid']
			),
			array(
				'%s'
			)
		);

	//duplicate settings
	$safe_sql=$wpdb->prepare( "INSERT INTO ".$wpdb->prefix ."lbg_audio9_html5_radio_zuper_settings (`playerWidth`, `imageHeight`, `radio_stream`, `radio_name`, `skin`, `autoPlay`, `responsive`, `centerTitle`, `songTitleColor`, `authorTitleColor`, `lineSeparatorColor`, `lineSeparatorOpacity`, `radioStationColor`, `buttonsOffState`, `buttonsOnState`, `frameBehindTextColor`, `frameBehindTextImg`, `playerBorderSize`, `playerBorderColor`, `sticky`, `startMinified`, `centerPlayer`, `showFacebookBut`, `facebookAppID`, `facebookShareTitle`, `facebookShareDescription`, `facebookShareImage`, `showTwitterBut`, `showVolume`, `showBio`, `translateBio`, `bioAndLyricsColor`, `showRadioStation`, `showTitle`, `showHistoryBut`, `translateReadingData`, `historyTranslate`, `historyTitleColor`, `historyBgColor`, `historyBgColorAlpha`, `historyRecordBgColor`, `historyRecordBottomBorderColor`, `historyRecordSongColor`, `historyRecordSongBottomBorderColor`, `historyRecordAuthorColor`, `historyRecordThumbBorderColor`, `numberOfThumbsPerScreen`, `historyPadding`, `historyRecordTitleLimit`, `historyRecordAuthorLimit`, `nowPlayingInterval`, `grabLastFmPhoto`, `noImageAvailable`, `textureOverImage`, `activateForFooter`, `preserveOriginalUpperLowerCase`, `delay`, `url_custom_metdata_file`, `metadata_file_type`) SELECT `playerWidth`, `imageHeight`, `radio_stream`, `radio_name`, `skin`, `autoPlay`, `responsive`, `centerTitle`, `songTitleColor`, `authorTitleColor`, `lineSeparatorColor`, `lineSeparatorOpacity`, `radioStationColor`, `buttonsOffState`, `buttonsOnState`, `frameBehindTextColor`, `frameBehindTextImg`, `playerBorderSize`, `playerBorderColor`, `sticky`, `startMinified`, `centerPlayer`, `showFacebookBut`, `facebookAppID`, `facebookShareTitle`, `facebookShareDescription`, `facebookShareImage`, `showTwitterBut`, `showVolume`, `showBio`, `translateBio`, `bioAndLyricsColor`, `showRadioStation`, `showTitle`, `showHistoryBut`, `translateReadingData`, `historyTranslate`, `historyTitleColor`, `historyBgColor`, `historyBgColorAlpha`, `historyRecordBgColor`, `historyRecordBottomBorderColor`, `historyRecordSongColor`, `historyRecordSongBottomBorderColor`, `historyRecordAuthorColor`, `historyRecordThumbBorderColor`, `numberOfThumbsPerScreen`, `historyPadding`, `historyRecordTitleLimit`, `historyRecordAuthorLimit`, `nowPlayingInterval`, `grabLastFmPhoto`, `noImageAvailable`, `textureOverImage`, `activateForFooter`, `preserveOriginalUpperLowerCase`, `delay`, `url_custom_metdata_file`, `metadata_file_type` FROM (".$wpdb->prefix ."lbg_audio9_html5_radio_zuper_settings) WHERE id = %d",$_SESSION['xid'] );
	$wpdb->query($safe_sql);
	?>
	<div id="message" class="updated"><p><?php echo $lbg_audio9_html5_radio_zuper_messages['duplicate_complete'];?></p></div>
	<?php

	//echo $wpdb->last_query;
	$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_audio9_html5_radio_zuper_players) ORDER BY id";
	$result = $wpdb->get_results($safe_sql,ARRAY_A);
	include_once($lbg_audio9_html5_radio_zuper_path . 'tpl/players.php');


}


function lbg_audio9_html5_radio_zuper_player_help_page()
{
	//include_once(plugins_url('tpl/help.php', __FILE__));
	global $lbg_audio9_html5_radio_zuper_path;
	include_once($lbg_audio9_html5_radio_zuper_path . 'tpl/help.php');
}

function lbg_audio9_html5_radio_zuper_player_color_parameter($the_param)
{
	$to_return="#";
	if ($the_param=="transparent") {
		$to_return="";
	}
	return $to_return;
}


function lbg_audio9_html5_radio_zuper_generate_preview_code($sliderID) {
	global $wpdb;

	$safe_sql=$wpdb->prepare( "SELECT * FROM (".$wpdb->prefix ."lbg_audio9_html5_radio_zuper_settings) WHERE id = %d",$sliderID );
	$row = $wpdb->get_row($safe_sql,ARRAY_A);
	$row=lbg_audio9_html5_radio_zuper_unstrip_array($row);


	$path_to_plugin = plugin_dir_url(__FILE__);
	$preload_aux='metadata';
	/*if ($row["preload"])
		$preload_aux=$row["preload"];*/



	$pathToAjaxFiles_aux=$path_to_plugin.'audio9_html5_radio_zuper/';

	$playlist_str='';
	/*foreach ( $result as $row_playlist ) {

		$row_playlist=lbg_audio9_html5_radio_zuper_unstrip_array($row_playlist);


		$mp3_path=$row_playlist["mp3"];
		$ogg_path=$row_playlist["ogg"];


		$playlist_str.='<ul>
                	<li class="xradiostream">'.$row_playlist["xradiostream"].'</li>';

        $playlist_str.=($row_playlist["xstation"]=='')?'':'<li class="xstation">'.$row_playlist["xstation"].'</li>';
        $playlist_str.='        </ul>';
	}*/

	$new_div_start='';
	$new_div_end='';

	$aux_frameBehindTextColor=lbg_audio9_html5_radio_zuper_player_color_parameter($row["frameBehindTextColor"]).$row["frameBehindTextColor"];
	if ($row["frameBehindTextImg"]) {
		$aux_frameBehindTextColor=$row["frameBehindTextImg"];
	}

	$content='<script>
		jQuery(function() {
			setTimeout(function(){
			jQuery("#lbg_audio9_html5_radio_zuper_'.$row["id"].'").audio9_html5({
				radio_stream:"'.$row["radio_stream"].'",
				radio_name:"'.$row["radio_name"].'",
				url_custom_metdata_file:"'.$row["url_custom_metdata_file"].'",
				metadata_file_type:"'.$row["metadata_file_type"].'",
				playerWidth:'.$row["playerWidth"].',
				imageHeight:'.$row["imageHeight"].',
				skin:"'.$row["skin"].'",
				responsive:'.$row["responsive"].',
				centerTitle:'.$row["centerTitle"].',
				grabLastFmPhoto:'.$row["grabLastFmPhoto"].',
				autoPlay:'.$row["autoPlay"].',
				songTitleColor:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["songTitleColor"]).$row["songTitleColor"].'",
				authorTitleColor:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["authorTitleColor"]).$row["authorTitleColor"].'",
				lineSeparatorColor:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["lineSeparatorColor"]).$row["lineSeparatorColor"].'",
				lineSeparatorOpacity:'.$row["lineSeparatorOpacity"].',
				radioStationColor:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["radioStationColor"]).$row["radioStationColor"].'",
				frameBehindTextColor:"'.$aux_frameBehindTextColor.'",
				buttonsOffState:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["buttonsOffState"]).$row["buttonsOffState"].'",
				buttonsOnState:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["buttonsOnState"]).$row["buttonsOnState"].'",
				sticky:'.$row["sticky"].',
				startMinified:'.$row["startMinified"].',
				centerPlayer:'.$row["centerPlayer"].',
				playerBorderSize:'.$row["playerBorderSize"].',
				playerBorderColor:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["playerBorderColor"]).$row["playerBorderColor"].'",
				showFacebookBut:'.$row["showFacebookBut"].',
				facebookAppID:"'.$row["facebookAppID"].'",
				facebookShareTitle:"'.$row["facebookShareTitle"].'",
				facebookShareDescription:"'.$row["facebookShareDescription"].'",
				facebookShareImage:"'.$row["facebookShareImage"].'",
				showTwitterBut:'.$row["showTwitterBut"].',
				showVolume:'.$row["showVolume"].',
				showBioBut:'.$row["showBio"].',
				translateBio:"'.$row["translateBio"].'",
				bioAndLyricsColor:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["bioAndLyricsColor"]).$row["bioAndLyricsColor"].'",
				showRadioStation:'.$row["showRadioStation"].',
				showTitle:'.$row["showTitle"].',
				showHistoryBut:'.$row["showHistoryBut"].',
				translateReadingData:"'.$row["translateReadingData"].'",
				historyTranslate:"'.$row["historyTranslate"].'",
				historyTitleColor:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["historyTitleColor"]).$row["historyTitleColor"].'",
				historyBgColor:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["historyBgColor"]).$row["historyBgColor"].'",
				historyBgColorAlpha:'.($row["historyBgColorAlpha"]/100).',
				historyRecordBgColor:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["historyRecordBgColor"]).$row["historyRecordBgColor"].'",
				historyRecordBottomBorderColor:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["historyRecordBottomBorderColor"]).$row["historyRecordBottomBorderColor"].'",
				historyRecordSongColor:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["historyRecordSongColor"]).$row["historyRecordSongColor"].'",
				historyRecordSongBottomBorderColor:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["historyRecordSongBottomBorderColor"]).$row["historyRecordSongBottomBorderColor"].'",
				historyRecordAuthorColor:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["historyRecordAuthorColor"]).$row["historyRecordAuthorColor"].'",
				historyRecordThumbBorderColor:"'.lbg_audio9_html5_radio_zuper_player_color_parameter($row["historyRecordThumbBorderColor"]).$row["historyRecordThumbBorderColor"].'",
				numberOfThumbsPerScreen:'.$row["numberOfThumbsPerScreen"].',
				historyPadding:'.$row["historyPadding"].',
				historyRecordTitleLimit:'.$row["historyRecordTitleLimit"].',
				historyRecordAuthorLimit:'.$row["historyRecordAuthorLimit"].',
				pathToAjaxFiles:"'.$pathToAjaxFiles_aux.'",
				nowPlayingInterval:'.$row["nowPlayingInterval"].',
				noImageAvailable:"'.$row["noImageAvailable"].'",
				preserveOriginalUpperLowerCase:'.$row["preserveOriginalUpperLowerCase"].',
				textureOverImage:"'.$row["textureOverImage"].'"
			});
			}, '.($row["delay"]*1000).');
		});
	</script>
    '.$new_div_start.'<div class="audio9_html5">
            <div id="lbg_audio9_html5_radio_zuper_'.$row["id"].'"></div>
     </div>
	'.$new_div_end;

	return str_replace("\r\n", '', $content);
}

function lbg_audio9_html5_radio_zuper_shortcode($atts, $content=null) {
	global $wpdb;

	shortcode_atts( array('settings_id'=>''), $atts);
	if ($atts['settings_id']=='')
		$atts['settings_id']=1;


	return lbg_audio9_html5_radio_zuper_generate_preview_code($atts['settings_id']);
}



register_activation_hook(__FILE__,"lbg_audio9_html5_radio_zuper_activate"); //activate plugin and create the database
add_action('init', 'lbg_audio9_html5_radio_zuper_init_sessions');	// initialize sessions
add_action('init', 'lbg_audio9_html5_radio_zuper_load_styles');	// loads required styles
add_action('init', 'lbg_audio9_html5_radio_zuper_load_scripts');			// loads required scripts
add_action('admin_menu', 'lbg_audio9_html5_radio_zuper_plugin_menu'); // create menus
add_shortcode('lbg_audio9_html5_radio_zuper', 'lbg_audio9_html5_radio_zuper_shortcode');				// LBG AUDIO9 HTML5 shortcode

add_action('wp_logout','lbg_audio9_html5_radio_zuper_end_sessions');
add_action('wp_login','lbg_audio9_html5_radio_zuper_end_sessions');







/** OTHER FUNCTIONS **/

//stripslashes for an entire array
function lbg_audio9_html5_radio_zuper_unstrip_array($array){
	if (is_array($array)) {
		foreach($array as &$val){
			if(is_array($val)){
				$val = unstrip_array($val);
			} else {
				$val = stripslashes($val);

			}
		}
	}
	return $array;
}



function lbg_audio9_html5_footer_function() {
	global $wpdb;
	$safe_sql=$wpdb->prepare( "SELECT `id`,`activateForFooter`,`sticky` FROM (".$wpdb->prefix ."lbg_audio9_html5_radio_zuper_settings)",1);
	$result = $wpdb->get_results($safe_sql,ARRAY_A);


	$shortcode_id=0;
	foreach ( $result as $row ) {
		$row=lbg_audio9_html5_radio_zuper_unstrip_array($row);
		if ($row['activateForFooter']==='true' && $row['sticky']==='true') {
			$shortcode_id=$row['id'];
		}
	}
	if ($shortcode_id>0)
    	echo do_shortcode("[lbg_audio9_html5_radio_zuper settings_id='".$shortcode_id."']");
}
add_action( 'wp_footer', 'lbg_audio9_html5_footer_function', 100 );





/* ajax update playlist record */

add_action('admin_head', 'lbg_audio9_html5_radio_zuper_update_playlist_record_javascript');

function lbg_audio9_html5_radio_zuper_update_playlist_record_javascript() {
	global $wpdb;
	//Set Your Nonce
	$lbg_audio9_html5_radio_zuper_update_playlist_record_ajax_nonce = wp_create_nonce("lbg_audio9_html5_radio_zuper_update_playlist_record-special-string");
	$lbg_audio9_html5_radio_zuper_preview_record_ajax_nonce = wp_create_nonce("lbg_audio9_html5_radio_zuper_preview_record-special-string");

	if(strpos($_SERVER['PHP_SELF'], 'wp-admin') !== false) {
			$page = (isset($_GET['page'])) ? $_GET['page'] : '';
			if(preg_match('/LBG_AUDIO9_HTML5_SHOUTCAST/i', $page)) {
?>



<script type="text/javascript" >
//delete the entire record
function lbg_audio9_html5_radio_zuper_delete_entire_record (delete_id) {
	if (confirm('Are you sure?')) {
		jQuery("#lbg_audio9_html5_radio_zuper_sortable").sortable('disable');
		jQuery("#"+delete_id).css("display","none");
		//jQuery("#lbg_audio9_html5_radio_zuper_sortable").sortable('refresh');
		jQuery("#lbg_audio9_html5_radio_zuper_updating_witness").css("display","block");
		var data = "action=lbg_audio9_html5_radio_zuper_update_playlist_record&security=<?php echo $lbg_audio9_html5_radio_zuper_update_playlist_record_ajax_nonce; ?>&updateType=lbg_audio9_html5_radio_zuper_delete_entire_record&delete_id="+delete_id;
		// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
		jQuery.post(ajaxurl, data, function(response) {
			jQuery("#lbg_audio9_html5_radio_zuper_sortable").sortable('enable');
			jQuery("#lbg_audio9_html5_radio_zuper_updating_witness").css("display","none");
			//alert('Got this from the server: ' + response);
		});
	}
}




function showDialogPreview(theSliderID) {  //load content and open dialog
	var data ="action=lbg_audio9_html5_radio_zuper_preview_record&security=<?php echo $lbg_audio9_html5_radio_zuper_preview_record_ajax_nonce; ?>&theSliderID="+theSliderID;

	// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
	jQuery.post(ajaxurl, data, function(response) {
		//jQuery("#previewDialog").html(response);
		jQuery('#previewDialogIframe').attr('src','<?php echo plugins_url("tpl/preview.html?d=".time(), __FILE__)?>');
		jQuery("#previewDialog").dialog("open");
	});
}


jQuery(document).ready(function($) {
	/*PREVIEW DIALOG BOX*/
	jQuery( "#previewDialog" ).dialog({
	  minWidth:1200,
	  minHeight:500,
	  title:"Plugin Preview",
	  modal: true,
	  autoOpen:false,
	  hide: "fade",
	  resizable: false,
	  open: function() {
		//jQuery( this ).html();
	  },
	  close: function() {
		//jQuery("#previewDialog").html('');
		jQuery('#previewDialogIframe').attr('src','');
	  }
	});

});
</script>
<?php
		}
	}
}







add_action('wp_ajax_lbg_audio9_html5_radio_zuper_preview_record', 'lbg_audio9_html5_radio_zuper_preview_record_callback');

function lbg_audio9_html5_radio_zuper_preview_record_callback() {
	check_ajax_referer( 'lbg_audio9_html5_radio_zuper_preview_record-special-string', 'security' );

	//echo lbg_audio9_html5_radio_zuper_generate_preview_code($_POST['theSliderID']);
	$aux_val='<html>
					<head>
						<link href="'.plugins_url('audio9_html5_radio_zuper/audio9_html5.css', __FILE__).'" rel="stylesheet" type="text/css">
						<link href="https://fonts.googleapis.com/css?family=PT+Sans:400,700" rel="stylesheet" type="text/css">

						<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.0/jquery.min.js" type="text/javascript"></script>
						<script src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.10.4/jquery-ui.min.js"></script>
						<script src="'.plugins_url('audio9_html5_radio_zuper/js/jquery.mousewheel.min.js', __FILE__).'" type="text/javascript"></script>
						<script src="'.plugins_url('audio9_html5_radio_zuper/js/jquery.touchSwipe.min.js', __FILE__).'" type="text/javascript"></script>
						<script src="'.plugins_url('audio9_html5_radio_zuper/js/audio9_html5.js', __FILE__).'" type="text/javascript"></script>

					</head>
					<body style="padding:0px;margin:0px;">';

	$aux_val.=lbg_audio9_html5_radio_zuper_generate_preview_code($_POST['theSliderID']);
	$aux_val.="</body>
				</html>";
	$filename=plugin_dir_path(__FILE__) . 'tpl/preview.html';
	$fp = fopen($filename, 'w+');
	$fwrite = fwrite($fp, $aux_val);

	echo $fwrite;

	die(); // this is required to return a proper result
}



?>
